##################################################
# FORMULAZIONE NELLO SCENARIO 1
##################################################
reset;

set SEAT;
set SCENARIO;

param cspace{SEAT};
param cprofi{SEAT};
param sell{SEAT,SCENARIO};

var x{SEAT} >= 0, integer;
var y{i in SEAT, j in SCENARIO} >= 0, integer, <= sell[i,j];

maximize mean_profit: sum{j in SCENARIO, i in SEAT}(y[i,j]*cprofi[i]);

s.t. capienza: sum{i in SEAT}x[i]*cspace[i] = 200;
s.t. v1{i in SEAT, j in SCENARIO}: y[i,j] <= x[i];


data;

set SEAT := FCL BSN ECO;
set SCENARIO := S1;

param: cspace cprofi := 
   FCL 2.0 3
   BSN 1.5 2
   ECO 1.0 1;

param sell :  S1  := 
		 FCL  20  
		 BSN  50  
		 ECO 200 ;

option solver cplex;
solve;
display x,y;

##################################################
# FORMULAZIONE NELLO SCENARIO 2
##################################################
reset;

set SEAT;
set SCENARIO;

param cspace{SEAT};
param cprofi{SEAT};
param sell{SEAT,SCENARIO};

var x{SEAT} >= 0, integer;
var y{i in SEAT, j in SCENARIO} >= 0, integer, <= sell[i,j];

maximize mean_profit: sum{j in SCENARIO, i in SEAT}(y[i,j]*cprofi[i]);

s.t. capienza: sum{i in SEAT}x[i]*cspace[i] = 200;
s.t. v1{i in SEAT, j in SCENARIO}: y[i,j] <= x[i];


data;

set SEAT := FCL BSN ECO;
set SCENARIO := S2;

param: cspace cprofi := 
   FCL 2.0 3
   BSN 1.5 2
   ECO 1.0 1;

param sell :  S2  := 
		 FCL  10  
		 BSN  25  
		 ECO 175 ;

option solver cplex;
solve;
display x,y;

##################################################
# FORMULAZIONE NELLO SCENARIO 3
##################################################
reset;

set SEAT;
set SCENARIO;

param cspace{SEAT};
param cprofi{SEAT};
param sell{SEAT,SCENARIO};

var x{SEAT} >= 0, integer;
var y{i in SEAT, j in SCENARIO} >= 0, integer, <= sell[i,j];

maximize mean_profit: sum{j in SCENARIO, i in SEAT}(y[i,j]*cprofi[i]);

s.t. capienza: sum{i in SEAT}x[i]*cspace[i] = 200;
s.t. v1{i in SEAT, j in SCENARIO}: y[i,j] <= x[i];


data;

set SEAT := FCL BSN ECO;
set SCENARIO := S3;

param: cspace cprofi := 
   FCL 2.0 3
   BSN 1.5 2
   ECO 1.0 1;

param sell :  S3  := 
		 FCL   5  
		 BSN  10  
		 ECO 150 ;

option solver cplex;
solve;
display x,y;


##################################################
# FORMULAZIONE STOCASTICA
##################################################
reset;

set SEAT;
set SCENARIO;

param cspace{SEAT};
param cprofi{SEAT};
param sell{SEAT,SCENARIO};

var x{SEAT} >= 0, integer;
var y{i in SEAT, j in SCENARIO} >= 0, integer, <= sell[i,j];

maximize mean_profit: sum{j in SCENARIO, i in SEAT}(y[i,j]*cprofi[i])/3;

s.t. capienza: sum{i in SEAT}x[i]*cspace[i] = 200;
s.t. v1{i in SEAT, j in SCENARIO}: y[i,j] <= x[i];


data;

set SEAT := FCL BSN ECO;
set SCENARIO := S1 S2 S3;

param: cspace cprofi := 
   FCL 2.0 3
   BSN 1.5 2
   ECO 1.0 1;

param sell :  S1  S2  S3 := 
		 FCL  20  10   5
		 BSN  50  25  10
		 ECO 200 175 150;

option solver cplex;
solve;
display x,y;

